#include "pfgoto.h"


/* score matrix for the initial alignement: gonnet 116.5 matrix see:
   Science . Vol 256 . 5June1992 . 1443 ff & J.Mol.Biol.(1995) 249, 816 ff */

score_m gonnet_init =
{

  "gonnet_init",
  
  116.5,                       /* PAM distance */ 

  LN10/10,                     /* Beta = (ln10)/10  */

  "CSTPAGNDEQHRKMILVFYWBXZ",   /* amino acid order */ 

  {
   11.5,
    0.1,  2.2,
   -0.5,  1.5,  2.5,
   -3.1,  0.4,  0.1,  7.6,
    0.5,  1.1,  0.6,  0.3,  2.4,
   -2.0,  0.4, -1.1, -1.6,  0.5,  6.6,
   -1.8,  0.9,  0.5, -0.9, -0.3,  0.4,  3.8,
   -3.2,  0.5,  0.0, -0.7, -0.3,  0.1,  2.2,  4.7,
   -3.0,  0.2, -0.1, -0.5,  0.0, -0.8,  0.9,  2.7,  3.6,
   -2.4,  0.2,  0.0, -0.2, -0.2, -1.0,  0.7,  0.9,  1.7,  2.7,
   -1.3, -0.2, -0.3, -1.1, -0.8, -1.4,  1.2,  0.4,  0.4,  1.2,  6.0,
   -2.2, -0.2, -0.2, -0.9, -0.6, -1.0,  0.3, -0.3,  0.4,  1.5,  0.6,  4.7,
   -2.8,  0.1,  0.1, -0.6, -0.4, -1.1,  0.8,  0.5,  1.2,  1.5,  0.6,  2.7,  3.2,
   -0.9, -1.4, -0.6, -2.4, -0.7, -3.5, -2.2, -3.0, -2.0, -1.0, -1.3, -1.7, -1.4,  4.3,
   -1.1, -1.8, -0.6, -2.6, -0.8, -4.5, -2.8, -3.8, -2.7, -1.9, -2.2, -2.4, -2.1,  2.5,  4.0,
   -1.5, -2.1, -1.3, -2.3, -1.2, -4.4, -3.0, -4.0, -2.8, -1.6, -1.9, -2.2, -2.1,  2.8,  2.8,  4.0,
    0.0, -1.0,  0.0, -1.8,  0.1, -3.3, -2.2, -2.9, -1.9, -1.5, -2.0, -2.0, -1.7,  1.6,  3.1,  1.8,  3.4,
   -0.8, -2.8, -2.2, -3.8, -2.3, -5.2, -3.1, -4.5, -3.9, -2.6, -0.1, -3.2, -3.3,  1.6,  1.0,  2.0,  0.1,  7.0,
   -0.5, -1.9, -1.9, -3.1, -2.2, -4.0, -1.4, -2.8, -2.7, -1.7,  2.2, -1.8, -2.1, -0.2, -0.7,  0.0, -1.1,  5.1, 7.8,
   -1.0, -3.3, -3.5, -5.0, -3.6, -4.0, -3.6, -5.2, -4.3, -2.7, -0.8, -1.6, -3.5, -1.0, -1.8, -0.7, -2.6,  3.6, 4.1, 14.2,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0,  0.0, 0.0,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0,  0.0, 0.0, 0.0,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0,  0.0, 0.0, 0.0, 0.0 },

  {6.00, 0.80},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  {14.0, 0.20},  /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  0.0,
};


/* blosum matrices, the blosum matrix series is taken from the dbclustal header matrices.h
   see also: Proc.Natl.Acad.Sci.USA; Nov.1992; Vol 89, 10915 ff */
/* blosum_30 */

static score_m blosum_30 =
{

  "blosum_30",

  30,  /* matrix derived from a data base of blocks in which sequence segments that are
			      identical at >= 30% of aligned residues are clustered */ 

  LN2/2,                         /* Beta = (ln2)/2  */
  
  "ABCDEFGHIKLMNPQRSTVWXYZ",     /* amino acid order */ 

  
  {
     4,
     0,  5,
    -3, -2, 17,
     0,  5, -3,  9,
     0,  0,  1,  1,  6,
    -2, -3, -3, -5, -4, 10,
     0,  0, -4, -1, -2, -3,  8,
    -2, -2, -5, -2,  0, -3, -3, 14,
     0, -2, -2, -4, -3,  0, -1, -2,  6,
     0,  0, -3,  0,  2, -1, -1, -2, -2,  4,
    -1, -1,  0, -1, -1,  2, -2, -1,  2, -2,  4,
     1, -2, -2, -3, -1, -2, -2,  2,  1,  2,  2,  6,
     0,  4, -1,  1, -1, -1,  0, -1,  0,  0, -2,  0,  8,
    -1, -2, -3, -1,  1, -4, -1,  1, -3,  1, -3, -4, -3, 11,
     1, -1, -2, -1,  2, -3, -2,  0, -2,  0, -2, -1, -1,  0,  8,
    -1, -2, -2, -1, -1, -1, -2, -1, -3,  1, -2,  0, -2, -1,  3,  8,
     1,  0, -2,  0,  0, -1,  0, -1, -1,  0, -2, -2,  0, -1, -1, -1,  4,
     1,  0, -2, -1, -2, -2, -2, -2,  0, -1,  0,  0,  1,  0,  0, -3,  2,  5,
     1, -2, -2, -2, -3,  1, -3, -3,  4, -2,  1,  0, -2, -4, -3, -1, -1,  1,  5,
    -5, -5, -2, -4, -1,  1,  1, -5, -3, -2, -2, -3, -7, -3, -1,  0, -3, -5, -3, 20,
     0, -1, -2, -1, -1, -1, -1, -1,  0,  0,  0,  0,  0, -1,  0, -1,  0,  0,  0, -2, -1,
    -4, -3, -6, -1, -2,  3, -3,  0, -1, -1,  3, -1, -4, -2, -1,  0, -2, -1,  1,  5, -1,  9,
     0,  0,  0,  0,  5, -4, -2,  0, -3,  1, -1, -1, -1,  0,  4,  0, -1, -1, -3, -1,  0, -2,  4 },

  {9.00, 1.00},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  {10.0, 1.50},   /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  0.0,
};


static score_m blosum_50 =
{

  "blosum_50",
  
   50,                             /* matrix derived from a data base of blocks in which sequence segments that are
				    identical at >= 50% of aligned residues are clustered */ 

  LN2/2,                            /* Beta = (ln2)/2  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",      /* amino acid order */ 

  {
     5,
    -2,  5,
    -1, -3, 13,
    -2,  5, -4,  8,
    -1,  1, -3,  2,  6,
    -3, -4, -2, -5, -3,  8,
     0, -1, -3, -1, -3, -4,  8,
    -2,  0, -3, -1,  0, -1, -2, 10,
    -1, -4, -2, -4, -4,  0, -4, -4,  5,
    -1,  0, -3, -1,  1, -4, -2,  0, -3,  6,
    -2, -4, -2, -4, -3,  1, -4, -3,  2, -3,  5,
    -1, -3, -2, -4, -2,  0, -3, -1,  2, -2,  3,  7,
    -1,  4, -2,  2,  0, -4,  0,  1, -3,  0, -4, -2,  7,
    -1, -2, -4, -1, -1, -4, -2, -2, -3, -1, -4, -3, -2, 10,
    -1,  0, -3,  0,  2, -4, -2,  1, -3,  2, -2,  0,  0, -1,  7,
    -2, -1, -4, -2,  0, -3, -3,  0, -4,  3, -3, -2, -1, -3,  1,  7,
     1,  0, -1,  0, -1, -3,  0, -1, -3,  0, -3, -2,  1, -1,  0, -1,  5,
     0,  0, -1, -1, -1, -2, -2, -2, -1, -1, -1, -1,  0, -1, -1, -1,  2,  5,
     0, -4, -1, -4, -3, -1, -4, -4,  4, -3,  1,  1, -3, -3, -3, -3, -2,  0,  5,
    -3, -5, -5, -5, -3,  1, -3, -3, -3, -3, -2, -1, -4, -4, -1, -3, -4, -3, -3, 15,
    -1, -1, -2, -1, -1, -2, -2, -1, -1, -1, -1, -1, -1, -2, -1, -1, -1,  0, -1, -3, -1,
    -2, -3, -3, -3, -2,  4, -3,  2, -1, -2, -1,  0, -2, -3, -1, -1, -2, -2, -1,  2, -1,  8,
    -1,  2, -3,  1,  5, -4, -2,  0, -3,  1, -3, -1,  0, -1,  4,  0,  0, -1, -3, -2, -1, -2,  5 },

  

  {9.50, 0.60},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  {9.50, 1.20},   /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  0.0,
};


static score_m blosum_62 =
{
  "blosum_62",
  
  62,                             /* matrix derived from a data base of blocks in which sequence segments that are
				    identical at >= 62% of aligned residues are clustered */ 
  LN2/2,                          /* Beta = (ln2)/2  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",      /* amino acid order */ 

  {
     4,
    -2,  4,
     0, -3,  9,
    -2,  4, -3,  6,
    -1,  1, -4,  2,  5,
    -2, -3, -2, -3, -3,  6,
     0, -1, -3, -1, -2, -3,  6,
    -2,  0, -3, -1,  0, -1, -2,  8,
    -1, -3, -1, -3, -3,  0, -4, -3,  4,
    -1,  0, -3, -1,  1, -3, -2, -1, -3,  5,
    -1, -4, -1, -4, -3,  0, -4, -3,  2, -2,  4,
    -1, -3, -1, -3, -2,  0, -3, -2,  1, -1,  2,  5,
    -2,  3, -3,  1,  0, -3,  0,  1, -3,  0, -3, -2,  6,
    -1, -2, -3, -1, -1, -4, -2, -2, -3, -1, -3, -2, -2,  7,
    -1,  0, -3,  0,  2, -3, -2,  0, -3,  1, -2,  0,  0, -1,  5,
    -1, -1, -3, -2,  0, -3, -2,  0, -3,  2, -2, -1,  0, -2,  1,  5,
     1,  0, -1,  0,  0, -2,  0, -1, -2,  0, -2, -1,  1, -1,  0, -1,  4,
     0, -1, -1, -1, -1, -2, -2, -2, -1, -1, -1, -1,  0, -1, -1, -1,  1,  5,
     0, -3, -1, -3, -2, -1, -3, -3,  3, -2,  1,  1, -3, -2, -2, -3, -2,  0,  4,
    -3, -4, -2, -4, -3,  1, -2, -2, -3, -3, -2, -1, -4, -4, -2, -3, -3, -2, -3, 11,
     0, -1, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -2, -1, -1,  0,  0, -1, -2, -1,
    -2, -3, -2, -3, -2,  3, -3,  2, -1, -2, -1, -1, -2, -3, -1, -2, -2, -2, -1,  2, -1,  7,
    -1,  1, -3,  1,  4, -3, -2,  0, -3,  1, -3, -1,  0, -1,  3,  0,  0, -1, -2, -3, -1, -2,  4 },

  

  {10.00, 0.60},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  {7.50, 0.90},   /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  0,
};

static score_m blosum_80 = 
{
  "blosum_80",
  
  80,                          /* matrix derived from a data base of blocks in which sequence segments that are
			           identical at >= 80 of aligned residues are clustered */ 

  LN2/2,                       /* Beta = (ln2)/2  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",   /* amino acid order */ 

  {
     7,
    -3,  6,
    -1, -6, 13,
    -3,  6, -7, 10,
    -2,  1, -7,  2,  8,
    -4, -6, -4, -6, -6, 10,
     0, -2, -6, -3, -4, -6,  9,
    -3, -1, -7, -2,  0, -2, -4, 12,
    -3, -6, -2, -7, -6, -1, -7, -6,  7,
    -1, -1, -6, -2,  1, -5, -3, -1, -5,  8,
    -3, -7, -3, -7, -6,  0, -7, -5,  2, -4,  6,
    -2, -5, -3, -6, -4,  0, -5, -4,  2, -3,  3,  9,
    -3,  5, -5,  2, -1, -6, -1,  1, -6,  0, -6, -4,  9,
    -1, -4, -6, -3, -2, -6, -5, -4, -5, -2, -5, -4, -4, 12,
    -2, -1, -5, -1,  3, -5, -4,  1, -5,  2, -4, -1,  0, -3,  9,
    -3, -2, -6, -3, -1, -5, -4,  0, -5,  3, -4, -3, -1, -3,  1,  9,
     2,  0, -2, -1, -1, -4, -1, -2, -4, -1, -4, -3,  1, -2, -1, -2,  7,
     0, -1, -2, -2, -2, -4, -3, -3, -2, -1, -3, -1,  0, -3, -1, -2,  2,  8,
    -1, -6, -2, -6, -4, -2, -6, -5,  4, -4,  1,  1, -5, -4, -4, -4, -3,  0,  7,
    -5, -8, -5, -8, -6,  0, -6, -4, -5, -6, -4, -3, -7, -7, -4, -5, -6, -5, -5, 16,
    -1, -3, -4, -3, -2, -3, -3, -2, -2, -2, -2, -2, -2, -3, -2, -2, -1, -1, -2, -5, -2,
    -4, -5, -5, -6, -5,  4, -6,  3, -3, -4, -2, -3, -4, -6, -3, -4, -3, -3, -3,  3, -3, 11,
    -2,  0, -7,  1,  6, -6, -4,  0, -6,  1, -5, -3, -1, -2,  5,  0, -1, -2, -4, -5, -1, -4,  6 },


  {14.50, 0.04},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  {7.00, 1.50},   /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  0.0,
};



/* PAM matrices, the PAM matrix series is taken from the dbclustal header matrices.h */

static score_m pam_20 =
{
  "pam_20",
  
  20,                             

  LN10/10,                        

  "ABCDEFGHIKLMNPQRSTVWXYZ",      

  {
     6,
    -5,  6,
    -8,-14, 10,
    -4,  6,-16,  8,
    -3,  0,-16,  2,  8,
    -9,-12,-15,-17,-16,  9,
    -3, -4,-11, -4, -5,-10,  7,
    -8, -2, -8, -5, -6, -7,-10,  9,
    -6, -7, -7, -9, -6, -3,-13,-11,  9,
    -8, -3,-16, -6, -5,-16, -8, -8, -7,  7,
    -7,-10,-17,-15,-10, -4,-12, -7, -2, -9,  7,
    -6,-12,-16,-13, -8, -5,-10,-13, -2, -3,  0, 11,
    -5,  6,-13,  1, -3,-10, -4, -1, -6, -2, -8,-11,  8,
    -2, -8, -9, -9, -7,-11, -7, -5,-10, -8, -8, -9, -7,  8,
    -5, -4,-16, -4,  0,-15, -8,  0, -9, -4, -6, -5, -5, -4,  9,
    -8, -9, -9,-12,-11,-10,-11, -3, -6, -1,-10, -5, -7, -5, -2,  9,
    -1, -2, -4, -5, -5, -7, -3, -7, -8, -5, -9, -6, -1, -3, -6, -4,  7,
    -1, -4, -9, -6, -7,-10, -7, -8, -3, -4, -8, -5, -3, -5, -7, -8,  0,  7,
    -3, -9, -7, -9, -8, -9, -7, -7,  1,-10, -3, -2, -9, -7, -8, -9, -8, -4,  7,
    -16,-11,-18,-17,-19, -6,-17, -8,-16,-14, -7,-15, -9,-16,-15, -3, -6,-15,-18, 13,
    -4, -6,-11, -7, -6, -9, -6, -6, -6, -6, -7, -6, -4, -6, -6, -7, -4, -5, -6,-13, -6,
    -9, -7, -5,-13, -9,  1,-16, -4, -7,-10, -8,-13, -5,-16,-14,-11, -8, -7, -8, -6, -9, 10,
    -4, -1,-16,  0,  6,-16, -6, -2, -7, -5, -8, -6, -4, -5,  7, -5, -6, -7, -8,-17, -6,-11,  6 },

  
  {12.50, 3.25}, /* !!!! These are the gap penalties for a pam30 matrix
		     (I think its bettter than guessing)
		     gap open und extend penalties for an all positive matrix see:
		     J.Mol.Biol.(1995) 249, 816 ff */ 

  {7.00, 1.00},  /* !!!! These are the gap penalties for a pam60+/-,
		    for pam30+/- {1.00, 3.00} was proposed - this is rather strange!
		    gap open und extend penalties for a +/- matrix see:
		    J.Mol.Biol.(1995) 249, 816 ff */ 

  0,
};

static score_m pam_60 =
{
  "pam_60",
  
  60,                            /* PAM distance */ 
  
  LN10/10,                       /* Beta = (ln10)/10  */
  
  "ABCDEFGHIKLMNPQRSTVWXYZ",     /* amino acid order */ 

  {
     5,
    -2,  5,
    -5, -9,  9,
    -2,  5,-10,  7,
    -1,  2,-10,  3,  7,
    -6, -8, -9,-11,-10,  8,
     0, -2, -7, -2, -2, -7,  6,
    -5,  0, -6, -2, -3, -4, -6,  8,
    -3, -4, -4, -5, -4, -1, -7, -6,  7,
    -5, -1,-10, -2, -3,-10, -5, -4, -4,  6,
    -4, -7,-11, -9, -7, -1, -8, -4,  0, -6,  6,
    -3, -6,-10, -7, -5, -2, -6, -7,  1,  0,  2, 10,
    -2,  5, -7,  2,  0, -6, -1,  1, -4,  0, -5, -6,  6,
     0, -4, -6, -5, -3, -7, -4, -2, -6, -4, -5, -6, -4,  7,
    -3, -1,-10, -1,  2, -9, -5,  2, -5, -1, -3, -2, -2, -1,  7,
    -5, -5, -6, -6, -6, -7, -7,  0, -4,  2, -6, -2, -3, -2,  0,  8,
     1,  0, -1, -2, -2, -5,  0, -4, -4, -2, -6, -4,  1,  0, -3, -2,  5,
     1, -2, -5, -3, -4, -6, -3, -5, -1, -2, -5, -2, -1, -2, -4, -4,  1,  6,
    -1, -5, -4, -6, -4, -5, -4, -5,  3, -6, -1,  0, -5, -4, -5, -5, -4, -1,  6,
    -10, -8,-12,-11,-12, -3,-11, -5,-10, -8, -4, -9, -6,-10, -9,  0, -4, -9,-11, 13,
    -2, -3, -6, -3, -3, -5, -3, -3, -3, -3, -4, -3, -2, -3, -3, -4, -2, -2, -3, -8, -3,
    -6, -5, -2, -8, -7,  3,-10, -2, -4, -7, -5, -7, -3,-10, -8, -8, -5, -5, -5, -3, -5,  9,
    -2,  1,-10,  2,  5,-10, -3,  0, -4, -2, -5, -4, -1, -2,  6, -2, -3, -4, -5,-11, -3, -7,  5 },

  
  {14.00, 1.50},   /* gap open und extend penalties for an all positive matrix see:
		     J.Mol.Biol.(1995) 249, 816 ff */

  {7.00, 1.00},   /* gap open und extend penalties for a +/- matrix see:
		    J.Mol.Biol.(1995) 249, 816 ff */

  0,
};

static score_m pam_120 =
{
  "pam_120",
  
  120,                           /* PAM distance */ 

  LN10/10,                       /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",     /* amino acid order */ 

  {
     3,
     0,  4,
    -3, -6,  9,
     0,  4, -7,  5,
     0,  3, -7,  3,  5,
    -4, -5, -6, -7, -7,  8,
     1,  0, -4,  0, -1, -5,  5,
    -3,  1, -4,  0, -1, -3, -4,  7,
    -1, -3, -3, -3, -3,  0, -4, -4,  6,
    -2,  0, -7, -1, -1, -7, -3, -2, -3,  5,
    -3, -4, -7, -5, -4,  0, -5, -3,  1, -4,  5,
    -2, -4, -6, -4, -3, -1, -4, -4,  1,  0,  3,  8,
    -1,  3, -5,  2,  1, -4,  0,  2, -2,  1, -4, -3,  4,
     1, -2, -4, -3, -2, -5, -2, -1, -3, -2, -3, -3, -2,  6,
    -1,  0, -7,  1,  2, -6, -3,  3, -3,  0, -2, -1,  0,  0,  6,
    -3, -2, -4, -3, -3, -5, -4,  1, -2,  2, -4, -1, -1, -1,  1,  6,
     1,  0,  0,  0, -1, -3,  1, -2, -2, -1, -4, -2,  1,  1, -2, -1,  3,
     1,  0, -3, -1, -2, -4, -1, -3,  0, -1, -3, -1,  0, -1, -2, -2,  2,  4,
     0, -3, -3, -3, -3, -3, -2, -3,  3, -4,  1,  1, -3, -2, -3, -3, -2,  0,  5,
    -7, -6, -8, -8, -8, -1, -8, -3, -6, -5, -3, -6, -4, -7, -6,  1, -2, -6, -8, 12,
    -1, -1, -4, -2, -1, -3, -2, -2, -1, -2, -2, -2, -1, -2, -1, -2, -1, -1, -1, -5, -2,
    -4, -3, -1, -5, -5,  4, -6, -1, -2, -5, -2, -4, -2, -6, -5, -5, -3, -3, -3, -2, -3,  8,
    -1,  2, -7,  3,  4, -6, -2,  1, -3, -1, -3, -2,  0, -1,  4, -1, -1, -2, -3, -7, -1, -5,  4 },

  
  {12.50, 1.00},   /* gap open und extend penalties for an all positive matrix see:
		     J.Mol.Biol.(1995) 249, 816 ff */

  {6.00, 1.40},   /* gap open und extend penalties for a +/- matrix see:
		    J.Mol.Biol.(1995) 249, 816 ff */
  0,

};



static score_m pam_350  =
{
  "pam_350",
  
  350,                          /* PAM distance */ 

  LN10/10,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  {
     2,
     1,  3,
    -2, -5, 18,
     1,  3, -6,  4,
     1,  3, -6,  4,  4,
    -4, -5, -5, -6, -6, 13,
     2,  1, -4,  1,  1, -6,  5,
    -1,  1, -4,  1,  1, -2, -2,  7,
     0, -2, -3, -2, -2,  2, -2, -2,  5,
    -1,  1, -6,  1,  0, -6, -1,  1, -2,  5,
    -2, -4, -7, -4, -4,  3, -4, -2,  4, -3,  8,
    -1, -2, -6, -3, -2,  1, -3, -2,  3,  0,  5,  6,
     0,  2, -4,  2,  2, -4,  1,  2, -2,  1, -3, -2,  2,
     1,  0, -3,  0,  0, -5,  0,  0, -2, -1, -3, -2,  0,  6,
     0,  2, -6,  2,  3, -5, -1,  3, -2,  1, -2, -1,  1,  1,  4,
    -1,  0, -4, -1,  0, -5, -2,  2, -2,  4, -3,  0,  1,  0,  2,  7,
     1,  1,  0,  1,  0, -4,  1, -1, -1,  0, -3, -2,  1,  1,  0,  0,  1,
     1,  0, -2,  0,  0, -3,  1, -1,  0,  0, -2, -1,  1,  1,  0, -1,  1,  2,
     0, -2, -2, -2, -2, -1, -1, -2,  4, -2,  3,  2, -2, -1, -2, -3, -1,  0,  5,
    -7, -6,-10, -8, -8,  1, -8, -3, -6, -4, -2, -5, -5, -7, -5,  4, -3, -6, -7, 27,
     0,  0, -3, -1,  0, -2, -1,  0,  0, -1, -1,  0,  0,  0,  0, -1,  0,  0,  0, -5, -1,
    -4, -4,  1, -5, -5, 11, -6,  0,  0, -5,  0, -2, -3, -6, -5, -5, -3, -3, -2,  1, -2, 14,
     0,  2, -6,  3,  3, -6,  0,  2, -2,  1, -3, -2,  2,  0,  3,  1,  0,  0, -2, -7,  0, -5,  3 },


  
  {12.50, 0.40},   /* gap penalties for pam 300+;
		     gap open und extend penalties for an all positive matrix see:
		     J.Mol.Biol.(1995) 249, 816 ff */

  {9.00, 2.40},   /* gap penalties for pam 300+/-;
		    gap open und extend penalties for a +/- matrix see:
		    J.Mol.Biol.(1995) 249, 816 ff */
  0,

};
/* DNA mat from clustal w */
score_m dnamt =
{
  "dnamt",
  
  0,                      /* no distances defined */    

  1,                      /* Beta = 1 => look for a better value */

  "ABCDGHKMNRSTUVWXY",    /* nucleic acid order */ 

  /* values as used in */
  {
    1,
    0,  0,
    0,  0,  1,
    0,  0,  0,  0,
    0,  0,  0,  0,  1,
    0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},

  {0.0, 0.0},   /* there's no use in defining +/- and all + DNA matrices !! */

  {3.0, 1.0},   /* gap penalties {opem,extend}  => use only p_n gap penalties */

  0,
};


/* gonnet matrices from clustalw(values are divided by 10), gap penalties are from Dayhoff matrices with
   corresponding pam distance calculated by Darwin_2.x */ 

static score_m gonnet_40 =
{
  "gonnet_40",
  
  40,                           /* PAM distance */    

  LN10/10,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
     9.2,
     0.0,  0.0,
    -3.1,  0.0, 16.3,
    -5.6,  0.0,-13.5, 11.1,
    -3.7,  0.0,-14.0,  1.6, 10.5,
    -9.2,  0.0, -6.4,-15.2,-14.3, 12.6,
    -3.2,  0.0, -9.1, -5.1, -7.6,-15.2, 10.5,
    -6.5,  0.0, -6.7, -4.1, -4.0, -5.0, -8.1, 14.5,
    -7.6,  0.0, -8.7,-15.0,-10.6, -3.9,-15.8, -9.4, 10.4,
    -5.4,  0.0,-13.2, -4.7, -1.3,-12.7, -7.9, -3.4, -8.6, 10.3,
    -6.8,  0.0, -8.5,-15.5,-10.8, -1.3,-14.1, -8.5,  0.5, -8.5,  8.9,
    -4.5,  0.0, -6.3,-13.0, -8.0, -1.6,-11.4, -6.0,  1.0, -5.7,  1.6, 14.0,
    -6.2,  0.0, -8.3,  0.6, -3.8,-10.4, -4.0, -0.7, -9.9, -2.0,-11.2, -9.1, 11.5,
    -3.7,  0.0,-13.7, -6.9, -6.0,-12.8, -8.7, -7.1,-10.8, -6.2, -8.3,-11.9, -7.8, 12.4,
    -4.3,  0.0,-11.3, -3.2,  1.0,-10.0, -7.1,  0.0, -9.1,  0.2, -6.0, -3.5, -2.5, -4.6, 11.8,
    -6.1,  0.0, -8.6, -7.7, -5.0,-13.0, -6.9, -3.1,-10.3,  1.9, -8.4, -8.1, -4.7, -7.3, -0.6, 11.2,
     0.0,  0.0, -3.5, -3.6, -4.1,-11.1, -3.7, -4.8, -9.5, -4.3, -9.5, -6.4, -1.1, -3.5, -3.5, -5.1,  9.9,
    -2.5,  0.0, -5.9, -4.7, -5.2, -9.0, -8.5, -4.6, -5.1, -3.4, -7.8, -4.4, -2.7, -4.2, -3.9, -5.2,  1.3, 10.0,
    -2.2,  0.0, -4.3,-13.3, -7.4, -5.8,-12.2, -9.8,  2.8, -8.2, -1.8, -2.2,-10.3, -8.6, -7.9, -8.8, -7.4, -2.5,  9.7,
   -12.0,  0.0, -6.8,-17.1,-13.1, -0.6,-10.8, -7.0, -9.3,-12.7, -7.1, -7.2,-11.9,-14.9, -8.7, -6.3, -9.8,-12.0,-11.5, 18.1,
     0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
    -9.5,  0.0, -5.6, -9.8,-10.7,  3.1,-12.9,  0.5, -7.6, -8.8, -6.4, -6.6, -6.2,-10.6, -8.1, -7.5, -6.9, -8.7, -7.3,  0.1,  0.0, 13.5,
     0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },


  {0.0, 0.0},         /* no gap penalties for all + matrices are defined */

  {25.73, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};


static score_m gonnet_80 =
{
  "gonnet_80",
  
  80,                           /* PAM distance */    

  LN10/10,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    7.5,
    0.0,  0.0,
   -1.0,  0.0, 15.4,
   -3.1,  0.0, -9.3,  9.6,
   -1.7,  0.0, -9.4,  3.1,  8.8,
   -6.4,  0.0, -3.9,-11.1,-10.2, 11.4,
   -1.1,  0.0, -6.1, -2.6, -4.7,-11.5,  9.7,
   -3.9,  0.0, -4.3, -1.7, -1.7, -2.6, -5.3, 12.7,
   -4.3,  0.0, -5.4,-10.6, -7.3, -1.5,-11.4, -6.4,  8.6,
   -3.0,  0.0, -8.8, -2.1,  0.4, -8.9, -5.0, -1.2, -5.9,  8.5,
   -4.3,  0.0, -5.5,-10.9, -7.5,  0.7,-10.4, -5.7,  2.2, -5.8,  7.7,
   -2.6,  0.0, -3.9, -8.8, -5.3,  0.3, -8.3, -3.8,  2.5, -3.7,  3.1, 11.7,
   -3.4,  0.0, -5.5,  2.1, -1.3, -7.5, -1.8,  0.9, -7.1, -0.2, -7.9, -6.2,  9.7,
   -1.6,  0.0, -9.3, -4.2, -3.5, -9.3, -5.8, -4.5, -7.5, -3.7, -5.8, -7.8, -4.8, 11.4,
   -2.2,  0.0, -7.6, -0.9,  2.3, -7.0, -4.4,  1.4, -6.0,  1.7, -3.9, -1.9, -0.6, -2.4,  9.5,
   -3.6,  0.0, -6.0, -4.4, -2.3, -9.0, -4.3, -1.0, -7.1,  3.3, -5.8, -5.3, -2.2, -4.5,  1.1,  9.7,
    1.4,  0.0, -1.5, -1.4, -1.9, -7.7, -1.6, -2.5, -6.2, -2.0, -6.4, -4.1,  0.5, -1.4, -1.5, -2.7,  7.8,
   -0.5,  0.0, -3.4, -2.4, -2.7, -6.2, -5.2, -2.4, -2.8, -1.5, -4.9, -2.5, -0.7, -2.0, -1.8, -2.7,  2.5,  8.1,
   -0.6,  0.0, -2.1, -8.9, -5.1, -3.1, -8.6, -6.5,  4.1, -5.4,  0.3,  0.1, -6.9, -5.7, -5.1, -6.0, -4.3, -0.9,  8.0,
   -8.7,  0.0, -4.3,-12.4, -9.8,  1.6, -8.1, -4.3, -6.3, -8.9, -4.4, -4.5, -8.6,-11.2, -6.2, -4.1, -7.2, -8.7, -8.0, 17.3,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -6.5,  0.0, -3.2, -6.9, -7.4,  4.9, -9.4,  2.1, -4.7, -6.0, -3.5, -3.7, -3.9, -7.6, -5.3, -5.0, -4.6, -5.8, -4.7,  2.3,  0.0, 12.3,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },

  
  {0.0, 0.0},         /* no gap penalties for all + matrices are defined */

  {23.492, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};


static score_m gonnet_120 =
{
  "gonnet_120",
  
  120,                           /* PAM distance */    

  LN10/10,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    5.9,
    0.0,  0.0,
   -0.1,  0.0, 14.4,
   -1.8,  0.0, -6.9,  8.2,
   -0.9,  0.0, -6.8,  3.5,  7.2,
   -4.8,  0.0, -2.6, -8.7, -7.8, 10.2,
   -0.3,  0.0, -4.5, -1.4, -3.1, -9.2,  9.0,
   -2.6,  0.0, -3.1, -0.7, -0.6, -1.4, -3.7, 11.0,
   -2.7,  0.0, -3.6, -8.0, -5.5, -0.3, -8.7, -4.8,  7.2,
   -1.9,  0.0, -6.4, -0.8,  1.1, -6.7, -3.4, -0.2, -4.4,  6.9,
   -3.0,  0.0, -3.9, -8.2, -5.7,  1.5, -8.2, -4.2,  2.8, -4.4,  6.6,
   -1.7,  0.0, -2.6, -6.4, -4.0,  1.1, -6.5, -2.8,  2.9, -2.7,  3.4,  9.5,
   -2.0,  0.0, -4.1,  2.6, -0.1, -5.8, -0.7,  1.4, -5.5,  0.5, -6.1, -4.6,  8.0,
   -0.6,  0.0, -6.8, -2.8, -2.2, -7.2, -4.1, -3.1, -5.6, -2.4, -4.4, -5.6, -3.2, 10.5,
   -1.2,  0.0, -5.6,  0.1,  2.5, -5.3, -3.0,  1.7, -4.3,  2.0, -3.0, -1.4,  0.1, -1.4,  7.4,
   -2.3,  0.0, -4.5, -2.7, -1.0, -6.8, -3.0, -0.1, -5.3,  3.6, -4.4, -3.8, -1.0, -3.0,  1.6,  8.3,
    1.6,  0.0, -0.7, -0.5, -0.9, -5.8, -0.6, -1.4, -4.4, -1.0, -4.7, -2.9,  1.0, -0.5, -0.7, -1.5,  6.0,
    0.2,  0.0, -2.1, -1.3, -1.5, -4.7, -3.5, -1.4, -1.7, -0.6, -3.4, -1.6,  0.0, -1.0, -0.9, -1.6,  2.6,  6.4,
    0.0,  0.0, -1.1, -6.5, -3.8, -1.7, -6.5, -4.7,  4.2, -3.9,  1.3,  1.0, -5.0, -4.2, -3.6, -4.4, -2.8, -0.3,  6.5,
   -6.8,  0.0, -2.9, -9.6, -7.8,  2.7, -6.6, -2.8, -4.6, -6.8, -2.9, -3.1, -6.8, -8.9, -4.9, -3.0, -5.7, -6.7, -5.9, 16.6,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -4.8,  0.0, -2.0, -5.3, -5.6,  5.5, -7.4,  2.6, -3.1, -4.4, -2.0, -2.2, -2.8, -5.9, -3.8, -3.7, -3.5, -4.2, -3.3,  3.3,  0.0, 11.1,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0  
  },


  
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {22.183, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};


static score_m gonnet_160 =
{
  "gonnet_160",
  
  160,                           /* PAM distance */    

  LN10/10,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    4.6,
    0.0,  0.0,
    0.3,  0.0, 13.5,
   -1.1,  0.0, -5.3,  7.0,
   -0.4,  0.0, -5.2,  3.4,  5.9,
   -3.8,  0.0, -1.8, -7.0, -6.2,  9.1,
    0.2,  0.0, -3.4, -0.7, -2.1, -7.6,  8.2,
   -1.8,  0.0, -2.3, -0.1, -0.1, -0.7, -2.7,  9.3,
   -1.8,  0.0, -2.5, -6.2, -4.3,  0.3, -7.0, -3.7,  5.9,
   -1.2,  0.0, -4.8, -0.1,  1.3, -5.3, -2.4,  0.2, -3.5,  5.5,
   -2.2,  0.0, -2.9, -6.5, -4.5,  1.9, -6.7, -3.2,  3.0, -3.4,  5.7,
   -1.2,  0.0, -1.9, -5.0, -3.1,  1.4, -5.2, -2.1,  2.9, -2.1,  3.4,  7.6,
   -1.2,  0.0, -3.1,  2.6,  0.5, -4.7, -0.2,  1.5, -4.4,  0.8, -4.8, -3.6,  6.5,
   -0.1,  0.0, -5.2, -1.9, -1.4, -5.8, -3.0, -2.2, -4.3, -1.6, -3.5, -4.2, -2.2,  9.6,
   -0.7,  0.0, -4.2,  0.6,  2.3, -4.1, -2.1,  1.7, -3.2,  2.0, -2.4, -1.2,  0.5, -0.8,  5.6,
   -1.6,  0.0, -3.5, -1.6, -0.3, -5.3, -2.1,  0.3, -4.1,  3.5, -3.5, -2.9, -0.4, -2.1,  1.7,  7.1,
    1.6,  0.0, -0.2,  0.0, -0.3, -4.5, -0.1, -0.8, -3.3, -0.4, -3.6, -2.3,  1.1,  0.0, -0.2, -0.9,  4.4,
    0.5,  0.0, -1.4, -0.6, -0.8, -3.6, -2.4, -0.8, -1.2, -0.2, -2.4, -1.1,  0.3, -0.4, -0.4, -0.9,  2.3,  5.0,
    0.1,  0.0, -0.6, -4.9, -3.0, -0.8, -5.2, -3.5,  4.0, -3.0,  1.7,  1.4, -3.8, -3.2, -2.7, -3.4, -2.0,  0.0,  5.3,
   -5.5,  0.0, -2.1, -7.8, -6.4,  3.2, -5.5, -1.9, -3.4, -5.4, -2.0, -2.2, -5.5, -7.4, -4.0, -2.4, -4.7, -5.4, -4.5, 15.8,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -3.7,  0.0, -1.3, -4.2, -4.4,  5.6, -6.0,  2.7, -2.0, -3.5, -1.1, -1.3, -2.2, -4.8, -2.9, -2.9, -2.8, -3.2, -2.4,  3.8,  0.0, 10.0,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },

  
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {21.255, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};



static score_m gonnet_250 =
{
  "gonnet_250",
  
  250,                           /* PAM distance */    

  LN10/10,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    2.4,
    0.0,  0.0,
    0.5,  0.0, 11.5,
   -0.3,  0.0, -3.2,  4.7,
    0.0,  0.0, -3.0,  2.7,  3.6,
   -2.3,  0.0, -0.8, -4.5, -3.9,  7.0,
    0.5,  0.0, -2.0,  0.1, -0.8, -5.2,  6.6,
   -0.8,  0.0, -1.3,  0.4,  0.4, -0.1, -1.4,  6.0,
   -0.8,  0.0, -1.1, -3.8, -2.7,  1.0, -4.5, -2.2,  4.0,
   -0.4,  0.0, -2.8,  0.5,  1.2, -3.3, -1.1,  0.6, -2.1,  3.2,
   -1.2,  0.0, -1.5, -4.0, -2.8,  2.0, -4.4, -1.9,  2.8, -2.1,  4.0,
   -0.7,  0.0, -0.9, -3.0, -2.0,  1.6, -3.5, -1.3,  2.5, -1.4,  2.8,  4.3,
   -0.3,  0.0, -1.8,  2.2,  0.9, -3.1,  0.4,  1.2, -2.8,  0.8, -3.0, -2.2,  3.8,
    0.3,  0.0, -3.1, -0.7, -0.5, -3.8, -1.6, -1.1, -2.6, -0.6, -2.3, -2.4, -0.9,  7.6,
   -0.2,  0.0, -2.4,  0.9,  1.7, -2.6, -1.0,  1.2, -1.9,  1.5, -1.6, -1.0,  0.7, -0.2,  2.7,
   -0.6,  0.0, -2.2, -0.3,  0.4, -3.2, -1.0,  0.6, -2.4,  2.7, -2.2, -1.7,  0.3, -0.9,  1.5,  4.7,
    1.1,  0.0,  0.1,  0.5,  0.2, -2.8,  0.4, -0.2, -1.8,  0.1, -2.1, -1.4,  0.9,  0.4,  0.2, -0.2,  2.2,
    0.6,  0.0, -0.5,  0.0, -0.1, -2.2, -1.1, -0.3, -0.6,  0.1, -1.3, -0.6,  0.5,  0.1,  0.0, -0.2,  1.5,  2.5,
    0.1,  0.0,  0.0, -2.9, -1.9,  0.1, -3.3, -2.0,  3.1, -1.7,  1.8,  1.6, -2.2, -1.8, -1.5, -2.0, -1.0,  0.0,  3.4,
   -3.6,  0.0, -1.0, -5.2, -4.3,  3.6, -4.0, -0.8, -1.8, -3.5, -0.7, -1.0, -3.6, -5.0, -2.7, -1.6, -3.3, -3.5, -2.6, 14.2,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -2.2,  0.0, -0.5, -2.8, -2.7,  5.1, -4.0,  2.2, -0.7, -2.1,  0.0, -0.2, -1.4, -3.1, -1.7, -1.8, -1.9, -1.9, -1.1,  4.1,  0.0,  7.8,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0  
  },

  
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {19.814, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};



static score_m gonnet_300 =
{
  "gonnet_300",
  
  300,                           /* PAM distance */    

  LN10/10,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    1.6,
    0.0,  0.0,
    0.5,  0.0, 10.4,
   -0.1,  0.0, -2.4,  3.7,
    0.1,  0.0, -2.3,  2.3,  2.7,
   -1.8,  0.0, -0.5, -3.7, -3.1,  6.0,
    0.5,  0.0, -1.5,  0.3, -0.4, -4.2,  5.8,
   -0.6,  0.0, -1.0,  0.5,  0.4,  0.0, -1.0,  4.5,
   -0.6,  0.0, -0.7, -3.0, -2.1,  1.1, -3.6, -1.6,  3.3,
   -0.2,  0.0, -2.1,  0.6,  1.1, -2.6, -0.7,  0.5, -1.7,  2.4,
   -0.9,  0.0, -1.0, -3.2, -2.2,  1.9, -3.6, -1.4,  2.5, -1.7,  3.3,
   -0.5,  0.0, -0.6, -2.4, -1.6,  1.5, -2.8, -1.0,  2.2, -1.1,  2.4,  3.1,
   -0.1,  0.0, -1.4,  1.8,  0.9, -2.5,  0.5,  1.0, -2.2,  0.8, -2.4, -1.7,  2.7,
    0.3,  0.0, -2.3, -0.4, -0.2, -3.0, -1.1, -0.8, -2.0, -0.3, -1.8, -1.9, -0.6,  6.6,
   -0.1,  0.0, -1.8,  0.9,  1.4, -2.0, -0.6,  0.9, -1.5,  1.3, -1.3, -0.8,  0.7, -0.1,  1.8,
   -0.4,  0.0, -1.7,  0.0,  0.5, -2.5, -0.6,  0.6, -1.9,  2.2, -1.8, -1.3,  0.4, -0.6,  1.3,  3.7,
    0.8,  0.0,  0.1,  0.5,  0.3, -2.2,  0.4, -0.1, -1.4,  0.2, -1.7, -1.1,  0.7,  0.4,  0.2,  0.0,  1.5,
    0.5,  0.0, -0.3,  0.1,  0.1, -1.7, -0.7, -0.1, -0.4,  0.2, -0.9, -0.5,  0.4,  0.2,  0.1, -0.1,  1.1,  1.7,
    0.0,  0.0,  0.1, -2.3, -1.5,  0.4, -2.6, -1.5,  2.6, -1.3,  1.7,  1.5, -1.7, -1.4, -1.2, -1.5, -0.8,  0.0,  2.6,
   -2.9,  0.0, -0.7, -4.2, -3.6,  3.6, -3.4, -0.5, -1.3, -2.8, -0.4, -0.6, -3.0, -4.1, -2.3, -1.4, -2.7, -2.8, -1.9, 13.2,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -1.7,  0.0, -0.3, -2.2, -2.2,  4.6, -3.3,  1.8, -0.3, -1.7,  0.3,  0.1, -1.2, -2.5, -1.4, -1.4, -1.5, -1.5, -0.7,  4.0,  0.0,  6.7,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },

  
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {19.225, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};



static score_m gonnet_350 =
{
  "gonnet_350",
  
  350,                           /* PAM distance */    

  LN10/10,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    1.0,
    0.0,  0.0,
    0.4,  0.0,  9.3,
    0.0,  0.0, -1.9,  2.9,
    0.1,  0.0, -1.7,  1.9,  2.0,
   -1.4,  0.0, -0.3, -3.0, -2.5,  5.1,
    0.5,  0.0, -1.2,  0.4, -0.2, -3.5,  5.1,
   -0.4,  0.0, -0.8,  0.5,  0.4,  0.1, -0.7,  3.3,
   -0.4,  0.0, -0.5, -2.4, -1.7,  1.1, -2.9, -1.3,  2.7,
   -0.1,  0.0, -1.6,  0.6,  0.9, -2.1, -0.4,  0.5, -1.3,  1.8,
   -0.7,  0.0, -0.7, -2.5, -1.8,  1.8, -3.0, -1.1,  2.2, -1.4,  2.8,
   -0.4,  0.0, -0.4, -1.9, -1.3,  1.4, -2.3, -0.8,  1.9, -0.9,  2.1,  2.3,
    0.0,  0.0, -1.1,  1.5,  0.9, -2.0,  0.5,  0.8, -1.8,  0.7, -1.9, -1.4,  2.0,
    0.3,  0.0, -1.8, -0.2,  0.0, -2.5, -0.7, -0.5, -1.6, -0.2, -1.5, -1.4, -0.3,  5.6,
    0.0,  0.0, -1.4,  0.8,  1.1, -1.6, -0.4,  0.7, -1.1,  1.0, -1.1, -0.7,  0.6,  0.0,  1.2,
   -0.2,  0.0, -1.3,  0.2,  0.6, -2.0, -0.4,  0.6, -1.5,  1.8, -1.4, -1.1,  0.4, -0.4,  1.0,  2.8,
    0.6,  0.0,  0.1,  0.5,  0.3, -1.8,  0.5,  0.0, -1.1,  0.2, -1.3, -0.9,  0.6,  0.4,  0.2,  0.1,  1.0,
    0.4,  0.0, -0.2,  0.2,  0.1, -1.3, -0.5, -0.1, -0.3,  0.2, -0.7, -0.4,  0.4,  0.2,  0.1,  0.0,  0.8,  1.1,
    0.0,  0.0,  0.2, -1.8, -1.2,  0.5, -2.1, -1.1,  2.2, -1.0,  1.6,  1.4, -1.3, -1.1, -0.9, -1.2, -0.6,  0.0,  2.1,
   -2.4,  0.0, -0.4, -3.5, -2.9,  3.5, -3.0, -0.3, -0.9, -2.3, -0.1, -0.3, -2.4, -3.4, -1.9, -1.2, -2.2, -2.3, -1.4, 12.4,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -1.4,  0.0, -0.1, -1.8, -1.7,  4.2, -2.7,  1.5, -0.1, -1.4,  0.5,  0.2, -1.0, -2.0, -1.1, -1.2, -1.2, -1.2, -0.4,  3.9,  0.0,  5.7,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },

      
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {18.727, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};


/*----------------------------------------------------------------------------------------------------------------------------------------*/
/* this fuction creates a score_m array XX-series, which contains pointers to all matrices of the XX matrix series */
score_m **init_matseries()
{
  score_m **matx;
    
  /* the pam and blosum series have each 4 members:
     pam_series [pam]: pam_20, pam_60, pam_120, pam_350; 
     blosum_series [blo]: blosum_30, blosum_50, blosum_62, blosum_80;

     the gonnet_series, which is the default series, has 7 members:
     gonnet_series [gon]: gonnet_40, gonnet_80, gonnet_120, gonnet_160,
                          gonnet_250, gonnet_300, gonnet_350;
  */
  
 
  if(strncasecmp(MAT_SER,"gon",3) == 0)
    {
      matx =(score_m**) calloc((7),sizeof(score_m*));

      matx[0]=&gonnet_40;
      matx[1]=&gonnet_80;
      matx[2]=&gonnet_120;
      matx[3]=&gonnet_160;
      matx[4]=&gonnet_250;
      matx[5]=&gonnet_300;
      matx[6]=&gonnet_350;
      

      if(plus() != 0)
	{
	  fprintf(stderr,"init_matseries: gon_p matrices are not available");
	  usage(0);
	  exit(20);
	}
    }
  else if(strncasecmp(MAT_SER,"blo",3) == 0)
    {
      matx =(score_m**) calloc((4),sizeof(score_m*));

      matx[0]=&blosum_30;
      matx[1]=&blosum_50;
      matx[2]=&blosum_62;
      matx[3]=&blosum_80;
    }
  else if(strncasecmp(MAT_SER,"pam",3) == 0)
    {
      matx =(score_m**) calloc((4),sizeof(score_m*));

      matx[0]=&pam_20;
      matx[1]=&pam_60;
      matx[2]=&pam_120;
      matx[3]=&pam_350;
    }
  else
  /*  if((strncasecmp(MAT_SER,"gon",3)!= 0) && (strncasecmp(MAT_SER,"blo",3)!= 0) && (strncasecmp(MAT_SER,"pam",3)!= 0)) */
    {
      fprintf(stderr,"init_matseries: error in scoring matrix selection, no score matrix selected");
       usage(0);
       exit(21);
    }
  return(matx);
  
}




























































































